<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2004/2005 Martin Tschosnig (martin.tschosnig@udo.edu)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'SlideImage' for the 'mt_slide' extension.
 *
 * @author	Martin Tschosnig <martin.tschosnig@udo.edu>
 */

/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 *
 *
 *   54: class tx_mtslide_pi1 extends tslib_pibase
 *   67:     function init($conf)
 *  114:     function main($content,$conf)
 *  131:     function buildSlideImage()
 *
 * TOTAL FUNCTIONS: 3
 * (This index is automatically created/updated by the extension "extdeveval")
 *
 */

require_once(PATH_tslib.'class.tslib_pibase.php');

/**
 * Class for the plugin 'SlideImage', extension 'mt_slide'
 *
 * @author	Martin Tschosnig <martin.tschosnig@udo.edu>
 * @package TYPO3
 * @subpackage tx_mtslide
 */
class tx_mtslide_pi1 extends tslib_pibase {
	var $prefixId = 'tx_mtslide_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_mtslide_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey = 'mt_slide';	// The extension key.
	var $uploadDir = 'uploads/tx_mtslide';

	/**
	 * Initializes the plugin
	 *
	 * @param	array		variable holding the $conf data
	 * @return	void		returns nothing, just fills up internal variables
	 * @access private
	 */
	function init($conf) {
		$this->conf=$conf;
		$this->pi_USER_INT_obj = 0;
		$this->pi_initPIflexForm();		
		require_once(t3lib_extMgm::extPath($this->extKey).'tx_mtslide_slidelib.php');

		$this->imgConf['width'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'image_width', 'sDEF') ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'image_width', 'sDEF') : 0;
		$this->imgConf['height'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'image_height', 'sDEF') ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'image_height', 'sDEF') : 0;
		$this->imgConf['resize'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'image_resize', 'sDEF');
		$this->imgConf['file'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'image_file', 'sDEF') ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'image_file', 'sDEF') : -1;

		$this->windowConf['width'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'window_width', 'sWindow') ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'window_width', 'sWindow') : $this->conf['windowWidth'];
		$this->windowConf['height'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'window_height', 'sWindow') ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'window_height', 'sWindow') : $this->conf['windowHeight'];
		$this->windowConf['align'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'window_align', 'sWindow') ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'window_align', 'sWindow') : '';
		$this->windowConf['float'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'float', 'sWindow');

		$this->slideConf['repeat_h'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'slide_repeat_pic_h', 'sSlide');
		$this->slideConf['repeat_v'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'slide_repeat_pic_v', 'sSlide');
		$this->slideConf['speed'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'slide_speed', 'sSlide') ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'slide_speed', 'sSlide') : $this->conf['slideSpeed'];

		switch((string)$this->imgConf['resize']) {
			case 'none':
				// no resize
				$this->imgConf['height'] = 0;
				$this->imgConf['width'] = 0;
			break;
			case 'width':
				// resize image to fit window width
				$this->imgConf['width'] = $this->windowConf['width'];
				$this->imgConf['height'] = 0;
			break;
			case 'height':
				// see 'width'
				$this->imgConf['height'] = $this->windowConf['height'];
				$this->imgConf['width'] = 0;
			break;
			default:
				// case 'value': nop, values set
			break;
		}
	}
	/**
	 * Main class of the SlideImage-Extension, inits object and renders content
	 *
	 * @param	array		$content
	 * @param	array		$conf: configuration from typo3
	 * @return	string		returns the rendered plugin content, XHTML
	 */
	function main($content,$conf)	{

		$this->init($conf);
		if ($this->imgConf['file'] != -1) {
			$content = $this->buildSlideImage();
		} else {
			$content = '';
		}

		return $this->pi_wrapInBaseClass($content);

	}
	/**
	 * Creates the HTML code for a single slide image
	 *
	 * @return	string		the rendered plugin content
	 */
	function buildSlideImage() {
		if ($this->imgConf['width'] > $this->conf['bannerMaxPixels']) {
			$this->imgConf['width'] = $this->conf['bannerMaxPixels'];
		}
		if ($this->imgConf['height'] > $this->conf['bannerMaxPixels']) {
			$this->imgConf['height'] = $this->conf['bannerMaxPixels'];
		}
		$image['maxW'] = $this->imgConf['width'].'m';
		$image['maxH'] = $this->imgConf['height'].'m';
		$imgres = $this->cObj->getImgResource($this->uploadDir.'/'.$this->imgConf['file'],$image);
		$this->imgConf['width'] = $imgres[0];
		$this->imgConf['height'] = $imgres[1];
		// set id to enable more than one img per page
		// format: pageID_contentID
		$content_id = explode(':',$GLOBALS['TSFE']->currentRecord);
		$img_id = $content_id[1];

		$content = tx_mtslide_slideLib::makeSlideImage($this->windowConf['height'], $this->windowConf['width'], $this->conf['gridRes'], $img_id, $this->windowConf['float']);

		$htmlTemplate = $this->cObj->fileResource('EXT:mt_slide/js_slide.tmpl');
		$tmpl = $this->cObj->getSubpart($htmlTemplate, '###JS_TEMPLATE###');
		$markerArray['###ID###'] = $img_id;
		$markerArray['###IMAGE_HEIGHT###'] = $this->imgConf['height'];
		$markerArray['###IMAGE_WIDTH###'] = $this->imgConf['width'];
		$markerArray['###IMAGE_BORDER_V###'] = $this->windowConf['height'] - $this->imgConf['height'];
		$markerArray['###IMAGE_BORDER_H###'] = $this->windowConf['width'] - $this->imgConf['width'];
		$markerArray['###WINDOW_SPEED###'] = $this->slideConf['speed'];
		$markerArray['###UPDATE_SCRIPT###'] = tx_mtslide_slideLib::getScript($this->slideConf['repeat_h'],$this->slideConf['repeat_v'], $img_id);

		$content .= $this->cObj->substituteMarkerArrayCached($tmpl, $markerArray, array(), array());
		switch($this->windowConf['align']) {
				case 1:
				$align = 'float:left;';
				break;
				case 2:
				$align = 'margin: 0 auto 0 auto;';
				break;
				case 3:
				$align = 'float:right;';
				break;
				default:
				$align = '';
				break;
			}
		$GLOBALS['TSFE']->additionalCSS['tx-mtslide-pi1'.$img_id] = '.tx-mtslide-pi1 DIV#tx-mtslide-slideimage'.$img_id.' {width: '. $this->windowConf['width']. 'px; height: '. $this->windowConf['height']. 'px; background-image: url('.$imgres[3].');}';
		$GLOBALS['TSFE']->additionalCSS['tx-mtslide-pi1-table'] = '.tx-mtslide-pi1 .tx-mtslide-maintable { width: '.$this->windowConf['width'].'px; height: '. $this->windowConf['height']. 'px; '.$align.' }';
		$GLOBALS['TSFE']->additionalCSS['tx-mtslide-pi1-tableimg'] = '.tx-mtslide-pi1 .tx-mtslide-maintable img { border:0; }';
		$GLOBALS['TSFE']->additionalCSS['tx-mtslide-pi1-sltable'] = '.tx-mtslide-pi1 .tx-mtslide-slideTable {width: '. $this->windowConf['width']. 'px; height: '. $this->windowConf['height']. 'px; border:0; padding:0; margin:0; border-collapse:collapse;}';
		$GLOBALS['TSFE']->additionalCSS['tx-mtslide-pi1-sltablecells'] = '.tx-mtslide-pi1 .tx-mtslide-slideTable td {border:0; padding:0; margin:0;}';
		return $content;
	}

}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/mt_slide/pi1/class.tx_mtslide_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/mt_slide/pi1/class.tx_mtslide_pi1.php']);
}

?>