<?php
	/***************************************************************
	*  Copyright notice
	*
	*  (c) 2004/2005 Martin Tschosnig (martin.tschosnig@udo.edu)
	*  All rights reserved
	*
	*  This script is part of the TYPO3 project. The TYPO3 project is
	*  free software; you can redistribute it and/or modify
	*  it under the terms of the GNU General Public License as published by
	*  the Free Software Foundation; either version 2 of the License, or
	*  (at your option) any later version.
	*
	*  The GNU General Public License can be found at
	*  http://www.gnu.org/copyleft/gpl.html.
	*
	*  This script is distributed in the hope that it will be useful,
	*  but WITHOUT ANY WARRANTY; without even the implied warranty of
	*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	*  GNU General Public License for more details.
	*
	*  This copyright notice MUST APPEAR in all copies of the script!
	***************************************************************/
	/**
	* Plugin 'SlideBanner' for the 'mt_slide' extension.
	*
	* @author Martin Tschosnig <martin.tschosnig@udo.edu>
	*/
	 
	/**
	* [CLASS/FUNCTION INDEX of SCRIPT]
	*
	*
	*
	*   55: class tx_mtslide_pi2 extends tslib_pibase
	*   68:     function init($conf)
	*  100:     function main($content,$conf)
	*  120:     function makeBanner()
	*  181:     function buildSlideImage()
	*
	* TOTAL FUNCTIONS: 4
	* (This index is automatically created/updated by the extension "extdeveval")
	*
	*/
	 
	require_once(PATH_tslib.'class.tslib_pibase.php');
	 
	/**
	* Class for the plugin 'SlideBanner', extension 'mt_slide'
	*
	* @author Martin Tschosnig <martin.tschosnig@udo.edu>
	* @package TYPO3
	* @subpackage tx_mtslide
	*/
	class tx_mtslide_pi2 extends tslib_pibase {
		var $prefixId = 'tx_mtslide_pi2';
		// Same as class name
		var $scriptRelPath = 'pi2/class.tx_mtslide_pi2.php'; // Path to this script relative to the extension dir.
		var $extKey = 'mt_slide'; // The extension key.
		var $uploadDir = 'uploads/tx_mtslide';
		 
		/**
		* Initializes the plugin
		*
		* @param array  variable holding the $conf data
		* @return void  returns nothing, just fills up internal variables
		* @access private
		*/
		function init($conf) {
			$this->conf = $conf;
			$this->pi_USER_INT_obj = 0;
			$this->pi_initPIflexForm();
			require_once(t3lib_extMgm::extPath($this->extKey).'tx_mtslide_slidelib.php');
			 
			$this->mode = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'mode', 'sDEF');
			$this->imgConf['file'] = explode(',', $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'banner_files', 'sDEF'));
			$this->windowConf['width'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'window_width', 'sWindow') ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'window_width', 'sWindow') :
			 $this->conf['windowWidth'];
			$this->windowConf['height'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'window_height', 'sWindow') ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'window_height', 'sWindow') :
			 $this->conf['windowHeight'];
			 
			if ($this->mode == 1) {
				$this->slideConf['repeat_v'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'banner_repeat', 'sSlide');
				$this->slideConf['repeat_h'] = 0;
				$this->imgConf['width'] = $this->windowConf['width'];
				$this->imgConf['height'] = 0;
			} else {
				$this->slideConf['repeat_h'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'banner_repeat', 'sSlide');
				$this->slideConf['repeat_v'] = 0;
				$this->imgConf['height'] = $this->windowConf['height'];
				$this->imgConf['width'] = 0;
			}
			$this->windowConf['align'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'window_align', 'sWindow') ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'window_align', 'sWindow') :
			 '';
			$this->windowConf['float'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'float', 'sWindow');
			$this->slideConf['speed'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'slide_speed', 'sSlide') ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'slide_speed', 'sSlide') :
			 $this->conf['slideSpeed'];
		}
		 
		/**
		* Main class of the SlideImage-Extension, inits object and renders content
		*
		* @param array  $content
		* @param array  $conf: configuration from typo3
		* @return string  returns the rendered plugin content, XHTML
		*/
		function main($content, $conf) {
			 
			$this->init($conf);
			 
			if (is_array($this->imgConf['file'])) {
				$this->makeBanner();
				$content = $this->buildSlideImage();
			} else {
				$content = '';
			}
			return $this->pi_wrapInBaseClass($content);
			 
		}
		 
		/**
		* Creates a banner from the selected images
		*
		* @return void  returns nothing, fills variables with values
		* @access private
		*/
		function makeBanner() {
			 
			$minSizeV = 0;
			$minSizeH = 0;
			$image['maxW'] = $this->imgConf['width'].'m';
			$image['maxH'] = $this->imgConf['height'].'m';
			$imgres[0] = $this->cObj->getImgResource($this->uploadDir.'/'.$this->imgConf['file'][0], $image);
			$minSizeV = $imgres[0][1];
			$minSizeH = $imgres[0][0];
			$num = count($this->imgConf['file']);
			for ($i = 1; $i < $num; ++$i) {
				$image['maxW'] = $this->imgConf['width'].'m';
				$image['maxH'] = $this->imgConf['height'].'m';
				$imgres[$i] = $this->cObj->getImgResource($this->uploadDir.'/'.$this->imgConf['file'][$i], $image);
				$minSizeV = ($minSizeV > $imgres[$i][1]) ? $imgres[$i][1] :
				 $minSizeV;
				$minSizeH = ($minSizeH > $imgres[$i][0]) ? $imgres[$i][0] :
				 $minSizeH;
			}
			$image['maxW'] = $minSizeH.'m';
			$image['maxH'] = $minSizeV.'m';
			 
			if ($this->mode == 0) {
				$image['maxW'] = 0;
				for ($i = 0; $i < $num; ++$i) {
					$imgres = $this->cObj->getImgResource($this->uploadDir.'/'.$this->imgConf['file'][$i], $image);
					$this->gifbuilder['file.'][($i+1).''] = 'IMAGE';
					$this->gifbuilder['file.'][($i+1).'.']['file'] = $imgres[3];
					if ($i == 0) {
						$this->gifbuilder['file.'][($i+1).'.']['offset'] = '0,0';
						$widthString = '[1.w]';
					} else {
						$this->gifbuilder['file.'][($i+1).'.']['offset'] = $widthString.',0';
						$widthString .= '+['.($i+1).'.w]';
					}
				}
				$this->gifbuilder['file.']['XY'] = $widthString.',[1.h]';
			} else {
				$image['maxH'] = 0;
				for ($i = 0; $i < $num; ++$i) {
					$imgres = $this->cObj->getImgResource($this->uploadDir.'/'.$this->imgConf['file'][$i], $image);
					$this->gifbuilder['file.'][($i+1).''] = 'IMAGE';
					$this->gifbuilder['file.'][($i+1).'.']['file'] = $imgres[3];
					if ($i == 0) {
						$this->gifbuilder['file.'][($i+1).'.']['offset'] = '0,0';
						$heightString = '[1.h]';
					} else {
						$this->gifbuilder['file.'][($i+1).'.']['offset'] = '0,'.$heightString;
						$heightString .= '+['.($i+1).'.h]';
					}
				}
				$this->gifbuilder['file.']['XY'] = '[1.w],'.$heightString;
			}
			$this->gifbuilder['file'] = 'GIFBUILDER';
			$this->gifbuilder['file.']['maxWidth'] = $this->mode ? $image['maxW'] :
			 $this->conf['bannerMaxPixels'];
			$this->gifbuilder['file.']['maxHeight'] = $this->mode ? $this->conf['bannerMaxPixels'] :
			 $image['maxH'];
			$this->gifbuilder['file.']['format'] = 'jpg';
		}
		/**
		* Creates the HTML code for a single slide image
		*
		* @return string  the rendered plugin content, XHTML
		*/
		function buildSlideImage() {
			 
			$imgres = $this->cObj->getImgResource($this->gifbuilder['file'], $this->gifbuilder['file.']);
			$this->imgConf['width'] = $imgres[0];
			$this->imgConf['height'] = $imgres[1];
			// set id to enable more than one img per page
			// format: pageID_contentID
			$content_id = explode(':', $GLOBALS['TSFE']->currentRecord);
			$img_id = $content_id[1];
			 
			$content = tx_mtslide_slideLib::makeSlideImage($this->windowConf['height'], $this->windowConf['width'], $this->conf['gridRes'], $img_id, $this->windowConf['float']);
			 
			$htmlTemplate = $this->cObj->fileResource('EXT:mt_slide/js_slide.tmpl');
			$tmpl = $this->cObj->getSubpart($htmlTemplate, '###JS_TEMPLATE###');
			$markerArray['###ID###'] = $img_id;
			$markerArray['###IMAGE_HEIGHT###'] = $this->imgConf['height'];
			$markerArray['###IMAGE_WIDTH###'] = $this->imgConf['width'];
			$markerArray['###IMAGE_BORDER_V###'] = $this->windowConf['height'] - $this->imgConf['height'];
			$markerArray['###IMAGE_BORDER_H###'] = $this->windowConf['width'] - $this->imgConf['width'];
			$markerArray['###WINDOW_SPEED###'] = $this->slideConf['speed'];
			$markerArray['###UPDATE_SCRIPT###'] = tx_mtslide_slideLib::getScript($this->slideConf['repeat_h'], $this->slideConf['repeat_v'], $img_id);
			 
			$content .= $this->cObj->substituteMarkerArrayCached($tmpl, $markerArray, array(), array());
			switch($this->windowConf['align']) {
				case 1:
				$align = 'float:left;';
				break;
				case 2:
				$align = 'margin: 0 auto 0 auto;';
				break;
				case 3:
				$align = 'float:right;';
				break;
				default:
				$align = '';
				break;
			}
			$GLOBALS['TSFE']->additionalCSS['tx-mtslide-pi1'.$img_id] = '.tx-mtslide-pi2 DIV#tx-mtslide-slideimage'.$img_id.' {width: '. $this->windowConf['width']. 'px; height: '. $this->windowConf['height']. 'px; background-image: url('.$imgres[3].');}';
			$GLOBALS['TSFE']->additionalCSS['tx-mtslide-pi1-table'] = '.tx-mtslide-pi2 .tx-mtslide-maintable { width: '.$this->windowConf['width'].'px; height: '. $this->windowConf['height']. 'px; '.$align.' }';
			$GLOBALS['TSFE']->additionalCSS['tx-mtslide-pi1-tableimg'] = '.tx-mtslide-pi2 .tx-mtslide-maintable img { border:0; }';
			$GLOBALS['TSFE']->additionalCSS['tx-mtslide-pi1-sltable'] = '.tx-mtslide-pi2 .tx-mtslide-slideTable {width: '. $this->windowConf['width']. 'px; height: '. $this->windowConf['height']. 'px; border:0; padding:0; margin:0; border-collapse:collapse;}';
			$GLOBALS['TSFE']->additionalCSS['tx-mtslide-pi1-sltablecells'] = '.tx-mtslide-pi2 .tx-mtslide-slideTable td {border:0; padding:0; margin:0;}';
			 return $content;
		}
		 
	}
	if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/mt_slide/pi2/class.tx_mtslide_pi2.php']) {
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/mt_slide/pi2/class.tx_mtslide_pi2.php']);
	}
	 
?>
